(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 12.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[   2408881,      56385]
NotebookOptionsPosition[   2405398,      56318]
NotebookOutlinePosition[   2405735,      56333]
CellTagsIndexPosition[   2405692,      56330]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell[BoxData[
 RowBox[{
  RowBox[{"B", "=", 
   RowBox[{"(", GridBox[{
      {"a", "0"},
      {"b", "c"}
     }], ")"}]}], ";", 
  RowBox[{"G", "=", 
   RowBox[{"(", GridBox[{
      {"A", "R"},
      {"F", "H"}
     }], ")"}]}]}]], "Input",
 CellChangeTimes->{{3.801763686457901*^9, 3.80176373000749*^9}},
 CellLabel->"In[1]:=",ExpressionUUID->"fd81b95d-c502-45f5-9102-bb336849abae"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "R"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"F", ",", "H"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.80176368972048*^9, 3.8017637305199223`*^9}, 
   3.8018144624173527`*^9},
 CellLabel->"Out[1]=",ExpressionUUID->"e18d792b-aea9-484f-a4e7-2259ca377cb4"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"-", "z"}], " ", 
       RowBox[{"(", GridBox[{
          {"1", "0"},
          {"0", "1"}
         }], ")"}]}], " ", "-", 
      RowBox[{"B", ".", 
       RowBox[{"Inverse", "[", "G", "]"}], ".", 
       RowBox[{"Transpose", "[", "B", "]"}]}]}], "\[Equal]", "G"}], ",", 
    RowBox[{"{", 
     RowBox[{"A", ",", "R", ",", "F", ",", "H"}], "}"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8017637360557413`*^9, 3.801763813272583*^9}, {
  3.8017640776872673`*^9, 3.801764078693881*^9}},
 CellLabel->"In[56]:=",ExpressionUUID->"76cf4fc6-b6ee-4c20-b555-3a77dc91f931"],

Cell[BoxData[
 InterpretationBox[
  TagBox[
   FrameBox[GridBox[{
      {
       ItemBox[
        TagBox[
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"A", "\[Rule]", 
              RowBox[{"-", "z"}]}], ",", 
             RowBox[{"R", "\[Rule]", 
              FractionBox[
               RowBox[{
                RowBox[{"a", " ", "z"}], "-", 
                RowBox[{"c", " ", "z"}], "+", 
                SqrtBox[
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", "c"}], "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"a", " ", "z"}], "-", 
                    RowBox[{"c", " ", "z"}]}], ")"}], "2"]}]]}], 
               RowBox[{"2", " ", "b"}]]}], ",", 
             RowBox[{"F", "\[Rule]", 
              FractionBox[
               RowBox[{
                RowBox[{"a", " ", "z"}], "-", 
                RowBox[{"c", " ", "z"}], "-", 
                SqrtBox[
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", "c"}], "+", 
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"a", " ", "z"}], "-", 
                    RowBox[{"c", " ", "z"}]}], ")"}], "2"]}]]}], 
               RowBox[{"2", " ", "b"}]]}], ",", 
             RowBox[{"H", "\[Rule]", "0"}]}], "}"}], ",", 
           TemplateBox[{"4"},
            "OutputSizeLimit`Skeleton"], ",", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"A", "\[Rule]", 
              FractionBox[
               RowBox[{
                TemplateBox[{"104"},
                 "OutputSizeLimit`Skeleton"], "+", 
                RowBox[{"3", " ", "a", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "4"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "3"]}], "-", 
                RowBox[{
                 SuperscriptBox["c", "3"], " ", 
                 SuperscriptBox["z", "4"], " ", 
                 SuperscriptBox[
                  RowBox[{"(", 
                   TemplateBox[{"1"},
                    "OutputSizeLimit`Skeleton"], ")"}], "3"]}]}], 
               RowBox[{
                RowBox[{"2", " ", 
                 SuperscriptBox["b", "4"], " ", 
                 SuperscriptBox["c", "5"]}], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["c", "6"]}], "+", 
                RowBox[{"4", " ", 
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["c", "7"]}], "+", 
                RowBox[{"a", " ", 
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["c", "4"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["c", "5"], " ", 
                 SuperscriptBox["z", "2"]}]}]]}], ",", 
             RowBox[{"R", "\[Rule]", 
              FractionBox[
               TemplateBox[{"1"},
                "OutputSizeLimit`Skeleton"], 
               TemplateBox[{"1"},
                "OutputSizeLimit`Skeleton"]]}], ",", 
             RowBox[{"F", "\[Rule]", 
              TemplateBox[{"1"},
               "OutputSizeLimit`Skeleton"]}], ",", 
             RowBox[{"H", "\[Rule]", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 RowBox[{
                  RowBox[{"-", 
                   SuperscriptBox["b", "4"]}], "+", 
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", "c"}], "+", 
                  TemplateBox[{"4"},
                   "OutputSizeLimit`Skeleton"], "+", 
                  RowBox[{"2", " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}]}], 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "+", 
               RowBox[{
                FractionBox["1", "2"], " ", 
                SqrtBox[
                 TemplateBox[{"1"},
                  "OutputSizeLimit`Skeleton"]]}], "+", 
               RowBox[{
                FractionBox["1", "2"], " ", 
                SqrtBox[
                 TemplateBox[{"1"},
                  "OutputSizeLimit`Skeleton"]]}]}]}]}], "}"}]}], "}"}],
         Short[#, 5]& ],
        BaseStyle->{Deployed -> False},
        StripOnInput->False]},
      {GridBox[{
         {
          PaneBox[
           TagBox[
            TooltipBox[
             StyleBox[
              StyleBox[
               DynamicBox[ToBoxes[
                 FEPrivate`FrontEndResource[
                 "FEStrings", "sizeBriefExplanation"], StandardForm],
                ImageSizeCache->{59., {2., 8.}}],
               StripOnInput->False,
               DynamicUpdating->True,
               LineSpacing->{1, 2},
               LineIndent->0,
               LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLText",
              StripOnInput->False],
             StyleBox[
              DynamicBox[
               ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"], 
                StandardForm]], DynamicUpdating -> True, LineIndent -> 0, 
              LinebreakAdjustments -> {1., 100, 0, 0, 0}, 
              LineSpacing -> {1, 2}, StripOnInput -> False]],
            Annotation[#, 
             Style[
              Dynamic[
               FEPrivate`FrontEndResource["FEStrings", "sizeExplanation"]], 
              DynamicUpdating -> True, LineIndent -> 0, 
              LinebreakAdjustments -> {1., 100, 0, 0, 0}, 
              LineSpacing -> {1, 2}], "Tooltip"]& ],
           Alignment->Center,
           BaselinePosition->Baseline,
           ImageSize->{Automatic, {25, Full}}], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm],
               ImageSizeCache->{51., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowLess"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, {25, Full}}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 56, 21119290077579669372, 5/2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm],
               ImageSizeCache->{56., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowMore"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, {25, Full}}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 56, 21119290077579669372, 5 2],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm],
               ImageSizeCache->{42., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeShowAll"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, {25, Full}}],
           Appearance->None,
           BaselinePosition->Baseline,
           
           ButtonFunction:>OutputSizeLimit`ButtonFunction[
            OutputSizeLimit`Defer, 56, 21119290077579669372, Infinity],
           Enabled->True,
           Evaluator->Automatic,
           Method->"Queued"], 
          ButtonBox[
           PaneSelectorBox[{False->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm],
               ImageSizeCache->{77., {0., 8.}}],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControl",
             StripOnInput->False], True->
            StyleBox[
             StyleBox[
              DynamicBox[ToBoxes[
                FEPrivate`FrontEndResource["FEStrings", "sizeChangeLimit"], 
                StandardForm]],
              StripOnInput->False,
              DynamicUpdating->True,
              LineSpacing->{1, 2},
              LineIndent->0,
              LinebreakAdjustments->{1., 100, 0, 0, 0}], "OSLControlActive",
             StripOnInput->False]}, Dynamic[
             CurrentValue["MouseOver"]],
            Alignment->Center,
            FrameMargins->0,
            ImageSize->{Automatic, {25, Full}}],
           Appearance->None,
           BaselinePosition->Baseline,
           ButtonFunction:>FrontEndExecute[{
              FrontEnd`SetOptions[
              FrontEnd`$FrontEnd, 
               FrontEnd`PreferencesSettings -> {"Page" -> "Advanced"}], 
              FrontEnd`FrontEndToken["PreferencesDialog"]}],
           Evaluator->None,
           Method->"Preemptive"]}
        },
        AutoDelete->False,
        FrameStyle->GrayLevel[0.85],
        GridBoxDividers->{"Columns" -> {False, {True}}},
        GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
        GridBoxSpacings->{"Columns" -> {{2}}}]}
     },
     DefaultBaseStyle->"Column",
     GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
     GridBoxDividers->{"Columns" -> {{False}}, "Rows" -> {{False}}},
     GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{1.}}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.5599999999999999]}, 
         Offset[0.27999999999999997`]}, "Rows" -> {
         Offset[0.2], 
         Offset[1.2], {
          Offset[0.4]}, 
         Offset[0.2]}}],
    BaseStyle->"OutputSizeLimit",
    FrameMargins->{{12, 12}, {0, 15}},
    FrameStyle->GrayLevel[0.85],
    RoundingRadius->5,
    StripOnInput->False],
   Deploy,
   DefaultBaseStyle->"Deploy"],
  If[21119290077579669372 === $SessionID, 
   Out[56], Message[
     MessageName[Syntax, "noinfoker"]]; Missing["NotAvailable"]; 
   Null]]], "Output",
 CellChangeTimes->{{3.801763752750702*^9, 3.80176381662074*^9}, 
   3.801764082024667*^9},
 CellLabel->"Out[56]=",ExpressionUUID->"5d54cd13-4a8b-4fbb-93cf-305a24db954e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"H", "/.", "sol"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "1"}], ",", 
     RowBox[{"b", "\[Rule]", "2"}], ",", 
     RowBox[{"c", "\[Rule]", "3"}], ",", 
     RowBox[{"z", "\[Rule]", "10"}]}], "}"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.801764013269516*^9, 
  3.801764094138076*^9}},ExpressionUUID->"6bee6d9b-79cc-4f08-ba91-\
dfd095acfbb5"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.`", ",", "0.`", ",", 
   RowBox[{"-", "8.507359879100296`"}], ",", 
   RowBox[{"-", "1.0064758356214112`"}], ",", 
   RowBox[{"-", "4.777253520011221`"}], ",", 
   RowBox[{"-", "1.1089107652670736`"}]}], "}"}]], "Output",
 CellChangeTimes->{{3.8017640149706993`*^9, 3.801764088277856*^9}},
 CellLabel->"Out[57]=",ExpressionUUID->"be52ce43-3023-481d-af7a-bcec94550a6e"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Tally", "[", 
  RowBox[{"{", 
   RowBox[{"0.`", ",", "0.`", ",", 
    RowBox[{"-", "8.507359879100296`"}], ",", 
    RowBox[{"-", "1.0064758356214112`"}], ",", 
    RowBox[{"-", "4.777253520011221`"}], ",", 
    RowBox[{"-", "1.1089107652670736`"}]}], "}"}], "]"}]], "Input",
 NumberMarks->False,
 CellLabel->"In[58]:=",ExpressionUUID->"f8d12dec-32a2-45a4-9fbd-ed845a50370b"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0.`", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "8.507359879100296`"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.0064758356214112`"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "4.777253520011221`"}], ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"-", "1.1089107652670736`"}], ",", "1"}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{3.801764096907041*^9},
 CellLabel->"Out[58]=",ExpressionUUID->"e9abba73-d0e8-4d12-8a13-2eb90fecd67d"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"A", "/.", 
  RowBox[{
  "sol", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}]], "Input",
 CellChangeTimes->{{3.8017641038164883`*^9, 3.801764114567813*^9}, 
   3.801764145422612*^9},
 CellLabel->"In[63]:=",ExpressionUUID->"eeea883f-3d18-455a-aa0d-a660875d270b"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"8", " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "4"], " ", "z"}], "-", 
    RowBox[{"12", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", "z"}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "5"], " ", "z"}], "+", 
    RowBox[{"16", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "6"], " ", "z"}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "7"], " ", "z"}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "3"]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "3"]}], "-", 
    RowBox[{"9", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"9", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "3"]}], "-", 
    RowBox[{"9", " ", "a", " ", 
     SuperscriptBox["c", "6"], " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["c", "7"], " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "5"]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "5"]}], "+", 
    RowBox[{"3", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "5"]}], "-", 
    RowBox[{
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "5"]}], "+", 
    RowBox[{"2", " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"4", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"8", " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"8", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"7", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "6"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "7"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"8", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "2"], " ", "c", " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"3", " ", "a", " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          RowBox[{"-", 
           SuperscriptBox["b", "4"]}], "+", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "-", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{"4", " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "6"], " ", "c", " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"10", " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "2"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"10", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "3"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"12", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"8", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["b", "4"], " ", "c", " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"5", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"15", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"15", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"7", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"15", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"5", " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", "c", " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "4"], " ", "c", " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "2"], " ", "c", " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"3", " ", "a", " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           RowBox[{"-", 
            SuperscriptBox["b", "4"]}], "+", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], "+", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "-", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"2", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "5"]}], "-", 
    RowBox[{"4", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "6"]}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "7"]}], "+", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.801764102088437*^9, 3.801764104898923*^9}, {
  3.801764142979946*^9, 3.801764145796117*^9}},
 CellLabel->"Out[63]=",ExpressionUUID->"f4781af1-f2b1-44d8-939a-232dfdbf73fb"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{"A", "/.", 
     RowBox[{"sol", "\[LeftDoubleBracket]", "3", "\[RightDoubleBracket]"}]}], 
    ")"}], "/.", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"a", "\[Rule]", "1"}], ",", 
     RowBox[{"b", "\[Rule]", "2"}], ",", 
     RowBox[{"c", "\[Rule]", "3"}], ",", 
     RowBox[{"z", "\[Rule]", "10"}]}], "}"}]}], "//", "N"}]], "Input",
 CellChangeTimes->{{3.801763814702304*^9, 3.8017638474615602`*^9}, {
  3.801763890736887*^9, 3.801763916347769*^9}, {3.801763953246867*^9, 
  3.8017639789742117`*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"1b12383f-bed6-4010-b2c3-0806eda19643"],

Cell[BoxData[
 RowBox[{"-", "9.898926204697743`"}]], "Output",
 CellChangeTimes->{
  3.801763916678281*^9, {3.8017639538917303`*^9, 3.801763979256122*^9}, 
   3.801764098630772*^9},
 CellLabel->"Out[59]=",ExpressionUUID->"db4d93a4-50e3-4dae-8905-ff390da27165"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.801763915155921*^9, 
  3.80176391555309*^9}},ExpressionUUID->"3db76207-7e24-4b4d-b5d6-\
edb130f7dd82"],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "95904"], 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "9766080"}], "+", 
    RowBox[{"8967968", " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox["73", "20"]}], "-", 
       FractionBox[
        SqrtBox["929"], "20"], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        SqrtBox[
         RowBox[{
          FractionBox["4443", "50"], "+", 
          FractionBox[
           RowBox[{"91", " ", 
            SqrtBox["929"]}], "50"]}]]}]}], ")"}]}], "+", 
    RowBox[{"3198080", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["73", "20"]}], "-", 
        FractionBox[
         SqrtBox["929"], "20"], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SqrtBox[
          RowBox[{
           FractionBox["4443", "50"], "+", 
           FractionBox[
            RowBox[{"91", " ", 
             SqrtBox["929"]}], "50"]}]]}]}], ")"}], "2"]}], "+", 
    RowBox[{"208000", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox["73", "20"]}], "-", 
        FractionBox[
         SqrtBox["929"], "20"], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         SqrtBox[
          RowBox[{
           FractionBox["4443", "50"], "+", 
           FractionBox[
            RowBox[{"91", " ", 
             SqrtBox["929"]}], "50"]}]]}]}], ")"}], "3"]}]}], 
   ")"}]}]], "Output",
 CellChangeTimes->{
  3.801763865004661*^9, {3.801763902785697*^9, 3.801763913869066*^9}},
 CellLabel->"Out[47]=",ExpressionUUID->"25fed305-edcc-47c5-9c6b-60059b0c2620"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.8017638449381733`*^9, 
  3.801763845360396*^9}},ExpressionUUID->"42fa885c-7650-4989-bc05-\
6b16ef8dee97"],

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "8"}], " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "4"], " ", "z"}], "+", 
    RowBox[{"12", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", "z"}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "5"], " ", "z"}], "-", 
    RowBox[{"16", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "6"], " ", "z"}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "7"], " ", "z"}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "3"]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "3"]}], "-", 
    RowBox[{"9", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"9", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "3"]}], "-", 
    RowBox[{"9", " ", "a", " ", 
     SuperscriptBox["c", "6"], " ", 
     SuperscriptBox["z", "3"]}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["c", "7"], " ", 
     SuperscriptBox["z", "3"]}], "-", 
    RowBox[{
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "5"]}], "+", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "5"]}], "-", 
    RowBox[{"3", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "5"]}], "+", 
    RowBox[{
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "5"]}], "-", 
    RowBox[{"2", " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"4", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"4", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"8", " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"8", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"7", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "6"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "7"], " ", 
     SuperscriptBox["z", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"8", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "4"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "2"], " ", "c", " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "+", 
    RowBox[{"3", " ", "a", " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "6"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         RowBox[{
          SuperscriptBox["b", "4"], "-", 
          RowBox[{"4", " ", "a", " ", 
           SuperscriptBox["b", "2"], " ", "c"}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["a", "2"], " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{
           SuperscriptBox["b", "2"], " ", 
           SuperscriptBox["z", "2"]}], "-", 
          RowBox[{"4", " ", "a", " ", "c", " ", 
           SuperscriptBox["z", "2"]}], "+", 
          RowBox[{"2", " ", 
           SuperscriptBox["c", "2"], " ", 
           SuperscriptBox["z", "2"]}]}], 
         RowBox[{"4", " ", 
          RowBox[{"(", 
           RowBox[{
            SuperscriptBox["a", "2"], "+", 
            SuperscriptBox["b", "2"], "-", 
            RowBox[{"2", " ", "a", " ", "c"}], "+", 
            SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"4", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "+", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"\[Sqrt]", 
         RowBox[{"(", 
          RowBox[{
           FractionBox[
            SuperscriptBox[
             RowBox[{"(", 
              RowBox[{
               SuperscriptBox["b", "4"], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c"}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"4", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
            RowBox[{"2", " ", 
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
             SuperscriptBox["z", "2"]}]], "-", 
           FractionBox[
            RowBox[{
             RowBox[{
              RowBox[{"-", 
               SuperscriptBox["b", "4"]}], " ", 
              SuperscriptBox["c", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "3"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{"4", " ", "a", " ", 
              SuperscriptBox["c", "3"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", 
              SuperscriptBox["c", "4"], " ", 
              SuperscriptBox["z", "2"]}]}], 
            RowBox[{
             RowBox[{
              SuperscriptBox["a", "2"], " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["b", "2"], " ", 
              SuperscriptBox["z", "2"]}], "-", 
             RowBox[{"2", " ", "a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}], "+", 
             RowBox[{
              SuperscriptBox["c", "2"], " ", 
              SuperscriptBox["z", "2"]}]}]], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "4"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "4"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "4"]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["a", "2"], "+", 
                SuperscriptBox["b", "2"], "-", 
                RowBox[{"2", " ", "a", " ", "c"}], "+", 
                SuperscriptBox["c", "2"]}], ")"}], " ", 
              SuperscriptBox["z", "2"]}], ")"}]}], "-", 
           RowBox[{
            RowBox[{"(", 
             RowBox[{
              RowBox[{"-", 
               FractionBox[
                SuperscriptBox[
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                 SuperscriptBox["z", "3"]}]]}], "+", 
              FractionBox[
               RowBox[{"16", " ", 
                RowBox[{"(", 
                 RowBox[{
                  RowBox[{
                   RowBox[{"-", "4"}], " ", "a", " ", 
                   SuperscriptBox["b", "2"], " ", 
                   SuperscriptBox["c", "3"]}], "+", 
                  RowBox[{
                   SuperscriptBox["a", "2"], " ", 
                   SuperscriptBox["c", "2"], " ", 
                   SuperscriptBox["z", "2"]}], "-", 
                  RowBox[{"2", " ", "a", " ", 
                   SuperscriptBox["c", "3"], " ", 
                   SuperscriptBox["z", "2"]}], "+", 
                  RowBox[{
                   SuperscriptBox["c", "4"], " ", 
                   SuperscriptBox["z", "2"]}]}], ")"}]}], 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox["a", "2"], "+", 
                  SuperscriptBox["b", "2"], "-", 
                  RowBox[{"2", " ", "a", " ", "c"}], "+", 
                  SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{"4", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["b", "4"], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                 SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
            RowBox[{"(", 
             RowBox[{"4", " ", 
              RowBox[{"\[Sqrt]", 
               RowBox[{"(", 
                RowBox[{
                 FractionBox[
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                  RowBox[{"4", " ", 
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                   SuperscriptBox["z", "2"]}]], "+", 
                 FractionBox[
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                  RowBox[{
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                 RowBox[{
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
             ")"}]}]}], ")"}]}]}]}], ")"}]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "6"], " ", "c", " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"10", " ", "a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "2"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"10", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "3"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"12", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", "z", " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"8", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["b", "4"], " ", "c", " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"5", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"15", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"15", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"7", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"15", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"5", " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "3"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", "c", " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "+", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "5"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "2"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["b", "4"], " ", "c", " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"2", " ", 
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"6", " ", 
     SuperscriptBox["a", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"6", " ", "a", " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"2", " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{
     SuperscriptBox["a", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{"3", " ", 
     SuperscriptBox["a", "2"], " ", "c", " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", "c", " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "+", 
    RowBox[{"3", " ", "a", " ", 
     SuperscriptBox["c", "2"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}], "-", 
    RowBox[{
     SuperscriptBox["c", "3"], " ", 
     SuperscriptBox["z", "4"], " ", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", 
         FractionBox[
          RowBox[{
           SuperscriptBox["b", "4"], "-", 
           RowBox[{"4", " ", "a", " ", 
            SuperscriptBox["b", "2"], " ", "c"}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["a", "2"], " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{
            SuperscriptBox["b", "2"], " ", 
            SuperscriptBox["z", "2"]}], "-", 
           RowBox[{"4", " ", "a", " ", "c", " ", 
            SuperscriptBox["z", "2"]}], "+", 
           RowBox[{"2", " ", 
            SuperscriptBox["c", "2"], " ", 
            SuperscriptBox["z", "2"]}]}], 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             SuperscriptBox["a", "2"], "+", 
             SuperscriptBox["b", "2"], "-", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"4", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "+", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], "-", 
        RowBox[{
         FractionBox["1", "2"], " ", 
         RowBox[{"\[Sqrt]", 
          RowBox[{"(", 
           RowBox[{
            FractionBox[
             SuperscriptBox[
              RowBox[{"(", 
               RowBox[{
                SuperscriptBox["b", "4"], "-", 
                RowBox[{"4", " ", "a", " ", 
                 SuperscriptBox["b", "2"], " ", "c"}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["a", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{
                 SuperscriptBox["b", "2"], " ", 
                 SuperscriptBox["z", "2"]}], "-", 
                RowBox[{"4", " ", "a", " ", "c", " ", 
                 SuperscriptBox["z", "2"]}], "+", 
                RowBox[{"2", " ", 
                 SuperscriptBox["c", "2"], " ", 
                 SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
             RowBox[{"2", " ", 
              SuperscriptBox[
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
              SuperscriptBox["z", "2"]}]], "-", 
            FractionBox[
             RowBox[{
              RowBox[{
               RowBox[{"-", 
                SuperscriptBox["b", "4"]}], " ", 
               SuperscriptBox["c", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "3"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{"4", " ", "a", " ", 
               SuperscriptBox["c", "3"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", 
               SuperscriptBox["c", "4"], " ", 
               SuperscriptBox["z", "2"]}]}], 
             RowBox[{
              RowBox[{
               SuperscriptBox["a", "2"], " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["b", "2"], " ", 
               SuperscriptBox["z", "2"]}], "-", 
              RowBox[{"2", " ", "a", " ", "c", " ", 
               SuperscriptBox["z", "2"]}], "+", 
              RowBox[{
               SuperscriptBox["c", "2"], " ", 
               SuperscriptBox["z", "2"]}]}]], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{
                RowBox[{"-", 
                 SuperscriptBox["b", "4"]}], " ", 
                SuperscriptBox["c", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "3"]}], "-", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["b", "2"], " ", "c", " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{
                SuperscriptBox["b", "2"], " ", 
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{"4", " ", "a", " ", 
                SuperscriptBox["c", "3"], " ", 
                SuperscriptBox["z", "2"]}], "-", 
               RowBox[{"2", " ", 
                SuperscriptBox["c", "4"], " ", 
                SuperscriptBox["z", "2"]}], "+", 
               RowBox[{
                SuperscriptBox["a", "2"], " ", 
                SuperscriptBox["z", "4"]}], "-", 
               RowBox[{"2", " ", "a", " ", "c", " ", 
                SuperscriptBox["z", "4"]}], "+", 
               RowBox[{
                SuperscriptBox["c", "2"], " ", 
                SuperscriptBox["z", "4"]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{
               RowBox[{"(", 
                RowBox[{
                 SuperscriptBox["a", "2"], "+", 
                 SuperscriptBox["b", "2"], "-", 
                 RowBox[{"2", " ", "a", " ", "c"}], "+", 
                 SuperscriptBox["c", "2"]}], ")"}], " ", 
               SuperscriptBox["z", "2"]}], ")"}]}], "-", 
            RowBox[{
             RowBox[{"(", 
              RowBox[{
               RowBox[{"-", 
                FractionBox[
                 SuperscriptBox[
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "3"], 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "3"], " ", 
                  SuperscriptBox["z", "3"]}]]}], "+", 
               FractionBox[
                RowBox[{"16", " ", 
                 RowBox[{"(", 
                  RowBox[{
                   RowBox[{
                    RowBox[{"-", "4"}], " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "+", 
                   RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                   RowBox[{"2", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                   RowBox[{
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}]}], 
                RowBox[{
                 RowBox[{"(", 
                  RowBox[{
                   SuperscriptBox["a", "2"], "+", 
                   SuperscriptBox["b", "2"], "-", 
                   RowBox[{"2", " ", "a", " ", "c"}], "+", 
                   SuperscriptBox["c", "2"]}], ")"}], " ", "z"}]], "+", 
               RowBox[{
                RowBox[{"(", 
                 RowBox[{"4", " ", 
                  RowBox[{"(", 
                   RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], " ", 
                  RowBox[{"(", 
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}]}], ")"}], "/", 
                RowBox[{"(", 
                 RowBox[{
                  SuperscriptBox[
                   RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                  SuperscriptBox["z", "3"]}], ")"}]}]}], ")"}], "/", 
             RowBox[{"(", 
              RowBox[{"4", " ", 
               RowBox[{"\[Sqrt]", 
                RowBox[{"(", 
                 RowBox[{
                  FractionBox[
                   SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["b", "4"], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c"}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"4", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}], ")"}], "2"], 
                   RowBox[{"4", " ", 
                    SuperscriptBox[
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], "2"], " ", 
                    SuperscriptBox["z", "2"]}]], "+", 
                  FractionBox[
                   RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}]}], 
                   RowBox[{
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}]}]], "-", 
                  RowBox[{
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{
                    RowBox[{"-", 
                    SuperscriptBox["b", "4"]}], " ", 
                    SuperscriptBox["c", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "3"]}], "-", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["b", "2"], " ", "c", " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{
                    SuperscriptBox["b", "2"], " ", 
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{"4", " ", "a", " ", 
                    SuperscriptBox["c", "3"], " ", 
                    SuperscriptBox["z", "2"]}], "-", 
                    RowBox[{"2", " ", 
                    SuperscriptBox["c", "4"], " ", 
                    SuperscriptBox["z", "2"]}], "+", 
                    RowBox[{
                    SuperscriptBox["a", "2"], " ", 
                    SuperscriptBox["z", "4"]}], "-", 
                    RowBox[{"2", " ", "a", " ", "c", " ", 
                    SuperscriptBox["z", "4"]}], "+", 
                    RowBox[{
                    SuperscriptBox["c", "2"], " ", 
                    SuperscriptBox["z", "4"]}]}], ")"}], "/", 
                   RowBox[{"(", 
                    RowBox[{
                    RowBox[{"(", 
                    RowBox[{
                    SuperscriptBox["a", "2"], "+", 
                    SuperscriptBox["b", "2"], "-", 
                    RowBox[{"2", " ", "a", " ", "c"}], "+", 
                    SuperscriptBox["c", "2"]}], ")"}], " ", 
                    SuperscriptBox["z", "2"]}], ")"}]}]}], ")"}]}]}], 
              ")"}]}]}], ")"}]}]}]}], ")"}], "3"]}]}], ")"}], "/", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", 
     SuperscriptBox["b", "4"], " ", 
     SuperscriptBox["c", "5"]}], "+", 
    RowBox[{"4", " ", "a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "6"]}], "-", 
    RowBox[{"4", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "7"]}], "+", 
    RowBox[{"a", " ", 
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "4"], " ", 
     SuperscriptBox["z", "2"]}], "-", 
    RowBox[{
     SuperscriptBox["b", "2"], " ", 
     SuperscriptBox["c", "5"], " ", 
     SuperscriptBox["z", "2"]}]}], ")"}]}]], "Output",
 CellChangeTimes->{{3.801763822824979*^9, 3.801763843136179*^9}},
 CellLabel->"Out[43]=",ExpressionUUID->"68db4526-a823-436e-be26-80be7d1946bf"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["G"], "Input",
 CellChangeTimes->{3.801763755765951*^9},
 CellLabel->"In[34]:=",ExpressionUUID->"4ed219a4-ca68-40a7-bf8e-9226811f234e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"A", ",", "R"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"F", ",", "H"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.801763756069688*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"b77dcc0b-7ee8-4edb-8d37-0b1f673f396c"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["B"], "Input",
 CellChangeTimes->{{3.801763756695985*^9, 3.801763757924349*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"36ca7484-78b9-4694-bf26-1e2e66486a89"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"a", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"b", ",", "c"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.801763758114674*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"a8f0d7c2-4ae0-4d62-a8ea-1ff49858bcaf"]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellChangeTimes->{{3.801763760287355*^9, 
  3.801763761064528*^9}},ExpressionUUID->"555584ee-613c-47b6-8a47-\
858d60fc1700"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"A", ",", "B", ",", "C", ",", "D"}], "]"}]], "Input",
 CellChangeTimes->{{3.801763702129487*^9, 3.8017637043369017`*^9}},
 CellLabel->"In[30]:=",ExpressionUUID->"62ca5088-e0e6-4a2b-9051-c1b0749e46cf"],

Cell[BoxData[
 TemplateBox[{
  "Clear","wrsym","\"Symbol \\!\\(\\*RowBox[{\\\"C\\\"}]\\) is Protected.\"",
   2,30,3,21119290077579669372,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.8017637047292967`*^9, 3.801763721160043*^9}},
 CellLabel->
  "During evaluation of \
In[30]:=",ExpressionUUID->"99d89018-42c4-40ce-9289-f81a92a9c0c1"],

Cell[BoxData[
 TemplateBox[{
  "Clear","wrsym","\"Symbol \\!\\(\\*RowBox[{\\\"D\\\"}]\\) is Protected.\"",
   2,30,4,21119290077579669372,"Local"},
  "MessageTemplate"]], "Message", "MSG",
 CellChangeTimes->{{3.8017637047292967`*^9, 3.801763721166978*^9}},
 CellLabel->
  "During evaluation of \
In[30]:=",ExpressionUUID->"a2f3e06c-8788-4fc7-a6db-905396853f98"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"\[IndentingNewLine]", 
  RowBox[{"Collect", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Det", "[", 
      RowBox[{
       RowBox[{"B", "/", "z"}], " ", "+", " ", 
       RowBox[{
        RowBox[{"Transpose", "[", "B", "]"}], "z"}], " ", "-", 
       RowBox[{"\[Lambda]", " ", 
        RowBox[{"(", GridBox[{
           {"1", "0"},
           {"0", "1"}
          }], ")"}]}]}], "]"}], "//", "Simplify"}], ",", "z"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.80181446451947*^9, 3.8018145052608967`*^9}},
 CellLabel->"In[9]:=",ExpressionUUID->"c8a47e50-2831-478b-baf9-d9b70a582aa8"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Solve", "[", 
  RowBox[{
   RowBox[{
    RowBox[{
     RowBox[{"-", 
      SuperscriptBox["b", "2"]}], "+", 
     RowBox[{"2", " ", "a", " ", "c"}], "+", 
     FractionBox[
      RowBox[{"a", " ", "c"}], 
      SuperscriptBox["z", "2"]], "+", 
     RowBox[{"a", " ", "c", " ", 
      SuperscriptBox["z", "2"]}], "+", 
     SuperscriptBox["\[Lambda]", "2"], "+", 
     FractionBox[
      RowBox[{
       RowBox[{
        RowBox[{"-", "a"}], " ", "\[Lambda]"}], "-", 
       RowBox[{"c", " ", "\[Lambda]"}]}], "z"], "+", 
     RowBox[{"z", " ", 
      RowBox[{"(", 
       RowBox[{
        RowBox[{
         RowBox[{"-", "a"}], " ", "\[Lambda]"}], "-", 
        RowBox[{"c", " ", "\[Lambda]"}]}], ")"}]}]}], " ", "\[Equal]", "0"}], 
   ",", "\[Lambda]"}], "]"}]], "Input",
 CellChangeTimes->{{3.80181451478443*^9, 3.8018145270736237`*^9}},
 CellLabel->"In[11]:=",ExpressionUUID->"160cd4ee-8dd7-457d-be17-271ec24cad52"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"\[Lambda]", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["a", "z"], "+", 
        FractionBox["c", "z"], "+", 
        RowBox[{"a", " ", "z"}], "+", 
        RowBox[{"c", " ", "z"}], "-", 
        SqrtBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["a", "z"]}], "-", 
             FractionBox["c", "z"], "-", 
             RowBox[{"a", " ", "z"}], "-", 
             RowBox[{"c", " ", "z"}]}], ")"}], "2"], "-", 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["b", "2"]}], "+", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             FractionBox[
              RowBox[{"a", " ", "c"}], 
              SuperscriptBox["z", "2"]], "+", 
             RowBox[{"a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}]}], ")"}]}]}]]}], ")"}]}]}], "}"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"\[Lambda]", "\[Rule]", 
     RowBox[{
      FractionBox["1", "2"], " ", 
      RowBox[{"(", 
       RowBox[{
        FractionBox["a", "z"], "+", 
        FractionBox["c", "z"], "+", 
        RowBox[{"a", " ", "z"}], "+", 
        RowBox[{"c", " ", "z"}], "+", 
        SqrtBox[
         RowBox[{
          SuperscriptBox[
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              FractionBox["a", "z"]}], "-", 
             FractionBox["c", "z"], "-", 
             RowBox[{"a", " ", "z"}], "-", 
             RowBox[{"c", " ", "z"}]}], ")"}], "2"], "-", 
          RowBox[{"4", " ", 
           RowBox[{"(", 
            RowBox[{
             RowBox[{"-", 
              SuperscriptBox["b", "2"]}], "+", 
             RowBox[{"2", " ", "a", " ", "c"}], "+", 
             FractionBox[
              RowBox[{"a", " ", "c"}], 
              SuperscriptBox["z", "2"]], "+", 
             RowBox[{"a", " ", "c", " ", 
              SuperscriptBox["z", "2"]}]}], ")"}]}]}]]}], ")"}]}]}], "}"}]}], 
  "}"}]], "Output",
 CellChangeTimes->{{3.801814518034479*^9, 3.801814527665269*^9}},
 CellLabel->"Out[11]=",ExpressionUUID->"66b2571a-ef7c-4449-98f4-11773a36b83b"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IdentityMatrix", "[", "2", "]"}]], "Input",
 CellChangeTimes->{{3.8018144854421263`*^9, 3.8018144925899277`*^9}},
 CellLabel->"In[5]:=",ExpressionUUID->"f3a67e76-bb6e-47c4-a4de-137165017470"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "0"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{3.801814492803701*^9},
 CellLabel->"Out[5]=",ExpressionUUID->"f6e7d214-1144-4693-b4d0-19aa29662b98"]
}, Open  ]]
},
WindowSize->{808, 905},
WindowMargins->{{28, Automatic}, {36, Automatic}},
FrontEndVersion->"12.0 for Mac OS X x86 (64-bit) (April 8, 2019)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 384, 13, 45, "Input",ExpressionUUID->"fd81b95d-c502-45f5-9102-bb336849abae"],
Cell[967, 37, 344, 9, 34, "Output",ExpressionUUID->"e18d792b-aea9-484f-a4e7-2259ca377cb4"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1348, 51, 695, 19, 45, "Input",ExpressionUUID->"76cf4fc6-b6ee-4c20-b555-3a77dc91f931"],
Cell[2046, 72, 13468, 343, 185, "Output",ExpressionUUID->"5d54cd13-4a8b-4fbb-93cf-305a24db954e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[15551, 420, 425, 12, 30, "Input",ExpressionUUID->"6bee6d9b-79cc-4f08-ba91-dfd095acfbb5"],
Cell[15979, 434, 410, 8, 34, "Output",ExpressionUUID->"be52ce43-3023-481d-af7a-bcec94550a6e"]
}, Open  ]],
Cell[CellGroupData[{
Cell[16426, 447, 399, 9, 30, "Input",ExpressionUUID->"f8d12dec-32a2-45a4-9fbd-ed845a50370b"],
Cell[16828, 458, 628, 19, 34, "Output",ExpressionUUID->"e9abba73-d0e8-4d12-8a13-2eb90fecd67d"]
}, Open  ]],
Cell[CellGroupData[{
Cell[17493, 482, 295, 6, 30, "Input",ExpressionUUID->"eeea883f-3d18-455a-aa0d-a660875d270b"],
Cell[17791, 490, 1193706, 27899, 41355, "Output",ExpressionUUID->"f4781af1-f2b1-44d8-939a-232dfdbf73fb"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1211534, 28394, 646, 16, 30, "Input",ExpressionUUID->"1b12383f-bed6-4010-b2c3-0806eda19643"],
Cell[1212183, 28412, 260, 5, 34, "Output",ExpressionUUID->"db4d93a4-50e3-4dae-8905-ff390da27165"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1212480, 28422, 151, 3, 30, "Input",ExpressionUUID->"3db76207-7e24-4b4d-b5d6-edb130f7dd82"],
Cell[1212634, 28427, 1666, 56, 154, "Output",ExpressionUUID->"25fed305-edcc-47c5-9c6b-60059b0c2620"]
}, Open  ]],
Cell[CellGroupData[{
Cell[1214337, 28488, 154, 3, 30, "Input",ExpressionUUID->"42fa885c-7650-4989-bc05-6b16ef8dee97"],
Cell[1214494, 28493, 1184281, 27615, 41171, "Output",ExpressionUUID->"68db4526-a823-436e-be26-80be7d1946bf"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2398812, 56113, 148, 2, 30, "Input",ExpressionUUID->"4ed219a4-ca68-40a7-bf8e-9226811f234e"],
Cell[2398963, 56117, 292, 8, 34, "Output",ExpressionUUID->"b77dcc0b-7ee8-4edb-8d37-0b1f673f396c"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2399292, 56130, 172, 2, 30, "Input",ExpressionUUID->"36ca7484-78b9-4694-bf26-1e2e66486a89"],
Cell[2399467, 56134, 292, 8, 34, "Output",ExpressionUUID->"a8f0d7c2-4ae0-4d62-a8ea-1ff49858bcaf"]
}, Open  ]],
Cell[2399774, 56145, 152, 3, 30, "Input",ExpressionUUID->"555584ee-613c-47b6-8a47-858d60fc1700"],
Cell[CellGroupData[{
Cell[2399951, 56152, 248, 4, 30, "Input",ExpressionUUID->"62ca5088-e0e6-4a2b-9051-c1b0749e46cf"],
Cell[2400202, 56158, 361, 8, 24, "Message",ExpressionUUID->"99d89018-42c4-40ce-9289-f81a92a9c0c1"],
Cell[2400566, 56168, 361, 8, 24, "Message",ExpressionUUID->"a2f3e06c-8788-4fc7-a6db-905396853f98"]
}, Open  ]],
Cell[2400942, 56179, 609, 17, 66, "Input",ExpressionUUID->"c8a47e50-2831-478b-baf9-d9b70a582aa8"],
Cell[CellGroupData[{
Cell[2401576, 56200, 940, 27, 48, InheritFromParent,ExpressionUUID->"160cd4ee-8dd7-457d-be17-271ec24cad52"],
Cell[2402519, 56229, 2317, 68, 169, "Output",ExpressionUUID->"66b2571a-ef7c-4449-98f4-11773a36b83b"]
}, Open  ]],
Cell[CellGroupData[{
Cell[2404873, 56302, 215, 3, 30, "Input",ExpressionUUID->"f3a67e76-bb6e-47c4-a4de-137165017470"],
Cell[2405091, 56307, 291, 8, 34, "Output",ExpressionUUID->"f6e7d214-1144-4693-b4d0-19aa29662b98"]
}, Open  ]]
}
]
*)

